set termout on
set echo on
spool gatherauto.log

-- This script is to show that GATHER AUTO ignores preferences

-- new table with no preferences

drop table test;

create table test as select * from dba_objects;

execute DBMS_STATS.GATHER_SCHEMA_STATS(NULL,options=>'GATHER AUTO');

select num_rows, SAMPLE_SIZE from user_tables where table_name='TEST';

-- set small estimate percent preference

drop table test;

create table test as select * from dba_objects;

execute DBMS_STATS.SET_TABLE_PREFS(NULL,'TEST','ESTIMATE_PERCENT','0.001');

-- regather with preference - sample_size doesn't change

execute DBMS_STATS.GATHER_SCHEMA_STATS(NULL,options=>'GATHER AUTO');

select num_rows, SAMPLE_SIZE from user_tables where table_name='TEST';

-- same thing but with GATHER

drop table test;

create table test as select * from dba_objects;

execute DBMS_STATS.SET_TABLE_PREFS(NULL,'TEST','ESTIMATE_PERCENT','0.001');

execute DBMS_STATS.GATHER_SCHEMA_STATS(NULL,options=>'GATHER');

select num_rows, SAMPLE_SIZE from user_tables where table_name='TEST';

-- same thing but with GATHER EMPTY

drop table test;

create table test as select * from dba_objects;

execute DBMS_STATS.SET_TABLE_PREFS(NULL,'TEST','ESTIMATE_PERCENT','0.001');

execute DBMS_STATS.GATHER_SCHEMA_STATS(NULL,options=>'GATHER EMPTY');

select num_rows, SAMPLE_SIZE from user_tables where table_name='TEST';

spool off
